#!/usr/bin/perl


#┌─────────────────────────────────
#│ PerlTkソフト v1.00 (2022/10/30)
#| update 2023/11/14
#│ Copyright (c) Dotmatrix
#│ info@cgishop.net
#│ https://cgishop.net/
#└─────────────────────────────────
$version = 'PerlTkソフト v1.00';
#┌─────────────────────────────────
#│ [注意事項]
#│ 1. このスクリプトは、フリーソフトです。このスクリプトを使用した
#│    いかなる損害に対して作者は、一切の責任を負いません。
#│ 2. 直接メールによる質問は、お受けいたしておりません。
#│    
#│ 3. 送信フォームのHTMLページの作成に関しては、創作自由です。
#│    スクリプトは、よく勉強してから改造してください。
#│ 4. 良いご意見が有ればHPで受け付けます。
#│    前向きに検討し、今後の参考とさせていただきます。
#└─────────────────────────────────

#
#  [ 設置例 ]
#
#  desktop / perltk.pl (実行権限）[755]
#                  
#

#-------------------------------------------------
#  ▼基本設定
#-------------------------------------------------

use Tk;
use Encode qw(decode);

use Tk::TextUndo;



# トップウィンドウを作る
$top = MainWindow->new();
#メインウィンドウのタイトル
$top->title(decode('utf8',"PerlTkソフト"));
$top->optionAdd( '*font' => 'ＭＳゴシック 10');

#-----------------------------------menu-------------------------------------


# メニューバーを作る
$menu = $top->Menu(-type => "menubar");
#メニューバーの設定
$top->configure(-menu => $menu, -width => 300, -height => 100);

# [File]メニューを作る
$menu1 = $menu->cascade(-label => 'File', -under => 0, -tearoff => 0);
$menu1->command(-label => 'Readme', -under => 0, -command => \&onReadme );
$menu1->separator;
$menu1->command(-label => 'Exit', -under => 0, -command => \&onExit);

# [View]メニューを作る
$menu2 = $menu->cascade(-label => 'View', -under => 0, -tearoff => 0);
$menu2->command(-label => 'perlpath', -under => 0, -command => \&onPerlpath );
$menu2->separator;
$menu2->command(-label => 'hirano', -under => 0, -command => \&onHirano);


#-----------------------------------表示ラベル-------------------------------------


$utext = $top -> Scrolled('TextUndo',
			-background =>'white',
			-width      => 40,
			-height     => 25,
			-wrap       => 'word',
			-scrollbars => 'se');
$utext -> pack( -side   => 'left',
		-fill   => 'both',
		-expand =>'yes');



#-----------------------------------フレームセット-------------------------------------

$f1 = $top->Frame()->pack(-anchor=>"w");
$f2 = $top->Frame()->pack(-anchor=>"w");
$f3 = $top->Frame()->pack(-anchor=>"w");
$f4 = $top->Frame()->pack(-anchor=>"w");
$f5 = $top->Frame()->pack(-anchor=>"w");
$f6 = $top->Frame()->pack(-anchor=>"w");
$f7 = $top->Frame()->pack(-anchor=>"w");

#-----------------------------------ボタン-------------------------------------

#-----------------------------------f1-------------------------------------

$f1->Button(-text => decode('utf8',"複数comment"), -command => \&onComment)->pack(-side => "left");

$f1->Button(-text => decode('utf8',"perl_path"), -command => \&onPerlpath)->pack(-side => "left");

$f1->Button(-text => decode('utf8',"tk_Top(スケルトン)"), -command => \&onTktop)->pack(-side => "left");

#-----------------------------------f2-------------------------------------

$f2->Button(-text => decode('utf8',"button"), -command => \&onButton)->pack(-side => "left");

$f2->Button(-text => decode('utf8',"menu"), -command => \&onMenu)->pack(-side => "left");

$f2->Button(-text => decode('utf8',"label"), -command => \&onLabel)->pack(-side => "left");

#-----------------------------------f3-------------------------------------

$f3->Button(-text => decode('utf8',"Frame"), -command => \&onFrame)->pack(-side => "left");

$f3->Button(-text => decode('utf8',"sub{関数}"), -command => \&onSub)->pack(-side => "left");

$f3->Button(-text => decode('utf8',"decode"), -command => \&onDecode)->pack(-side => "left");

#-----------------------------------f4-------------------------------------

$f4->Button(-text => decode('utf8',"Code_end"), -command => \&onCodend)->pack(-side => "left");

$f4->Button(-text => decode('utf8',"tab_page"), -command => \&onPageframe)->pack(-side => "left");

$f4->Button(-text => decode('utf8',"フォーム"), -command => \&onForm)->pack(-side => "left");

#-----------------------------------f5-------------------------------------


$f5->Button(-text => decode('utf8',"IPアドレス確認"), -command => \&onIpadd)->pack(-side => "left");

$f5->Button(-text => decode('utf8',"sendmail"), -command => \&onSendmail)->pack(-side => "left");

$f5->Button(-text => decode('utf8',"インターフェース状況"), -command => \&onNetstat)->pack(-side => "left");

#-----------------------------------f6-------------------------------------

$f6->Button(-text => decode('utf8',"bashシェルのパス"), -command => \&onBash)->pack(-side => "left");

$f6->Button(-text => decode('utf8',"CGI_template"), -command => \&onCgitemp)->pack(-side => "left");

$f6->Button(-text => decode('utf8',"Text_undo"), -command => \&onTextundo)->pack(-side => "left");







#-----------------------------------コピーボタン-------------------------------------
$f7->Label(-text => "-------------------------------------------")->pack(-side => "top");
$f7->Button(-fg => 'blue',-font => ['','10','bold'],-text => decode('utf8',"Copy"),-background => "white", -command => \&copy)->pack(-side => "top");

sub copy {
    $gettxt = $utext -> get('1.0' , 'end');
    $top->clipboardClear; 
    $top->clipboardAppend('--', $gettxt ); 
    
};
$f7->Label(-text => "-------------------------------------------")->pack(-side => "top");

$f7->Button(-text => decode('utf8',"終了"), -command => \&onExit,-background => "white")->pack(-side => "top",-anchor => "e");

#-----------------------------------サブルーチン-------------------------------------

#表示部textundo
sub onTextundo{

$text = <<'EOS';


#---------表示部--------------

use Tk::TextUndo;

$utext = $top -> Scrolled('TextUndo',
			-background =>'white',
			-width      => 40,
			-height     => 25,
			-wrap       => 'word',
			-scrollbars => 'se');
$utext -> pack( -side   => 'left',
		-fill   => 'both',
		-expand =>'yes');

EOS
    
    $labelText = decode('utf8',$text); 
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText);
}


#ヒアドキュメント
sub onComment{

$text = <<'EOS';

=pod
上の=podから下の=cutまでがコメント扱い
Shigemitsu Hirano

hirano@cgishop.net

https://cgishop.net
=cut

EOS
    
    $labelText = decode('utf8',$text); 
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText);
}


# perlpath表示
sub onPerlpath {
    $labelText = `which perl`;    
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText);
};

#スケルトン生成
sub onTktop{

$text = <<'EOS';

#!/usr/bin/perl


use Tk;
use Encode qw(decode);


# トップウィンドウを作る
$top = MainWindow->new();
#メインウィンドウのタイトル
$top->title(decode('utf8',"PerlTkソフト"));
$top->optionAdd( '*font' => 'ＭＳゴシック 10');
#####################
#
#
#
#ここに処理を書きます
#いわゆるスケルトン
#
#
#####################

# メインループ
MainLoop();

EOS

    $labelText = decode('utf8',$text); 
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText);
}


#ボタン生成
sub onButton{

$text = <<'EOS';

$button = $top->Button(-text => decode('utf8',"tk_Top"), -command => \&onTktop)->pack(-side => "left");


#####################
#
#メイン画面にボタンを載せます
#
#
#
#
#
#####################

EOS

    $labelText = decode('utf8',$text); 
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText);
}


#ボタン生成
sub onMenu{

$text = <<'EOS';

# メニューバーを作る
$menu = $top->Menu(-type => "menubar");
#メニューバーの設定
$top->configure(-menu => $menu, -width => 300, -height => 100);

# [File]メニューを作る
$menu1 = $menu->cascade(-label => 'File', -under => 0, -tearoff => 0);
$menu1->command(-label => 'Readme', -under => 0, -command => \&onReadme );
$menu1->separator;
$menu1->command(-label => 'Exit', -under => 0, -command => \&onExit);

# [View]メニューを作る
$menu2 = $menu->cascade(-label => 'View', -under => 0, -tearoff => 0);
$menu2->command(-label => 'perlpath', -under => 0, -command => \&onPerlpath );
$menu2->separator;
$menu2->command(-label => 'hirano', -under => 0, -command => \&onHirano);

#####################
#
#menuを生成します
#
#
#
#
#
#####################

EOS

    $labelText = decode('utf8',$text); 
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText);
}


#-----------------------------------f2-------------------------------------

#ラベル生成
sub onLabel{

$text = <<'EOS';

$label = $top->Label(-text => "ラベル")->pack(-side => "top");


#####################
#
#メイン画面にラベルを載せます
#
#
#
#
#
#####################

EOS

    $labelText = decode('utf8',$text); 
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText);
}

#フレーム生成
sub onFrame{

$text = <<'EOS';

$f1 = $top->Frame()->pack();
$f2 = $top->Frame()->pack();


$f1->Button(-text => decode('utf8',"複数comment"), -command => \&onComment)->pack(-side => "left");
$f1->Button(-text => decode('utf8',"複数comment"), -command => \&onComment)->pack(-side => "left");
$f1->Button(-text => decode('utf8',"複数comment"), -command => \&onComment)->pack(-side => "left");


$f2->Button(-text => decode('utf8',"perl_path"), -command => \&onPerlpath)->pack(-side => "left");
$f2->Button(-text => decode('utf8',"perl_path"), -command => \&onPerlpath)->pack(-side => "left");
$f2->Button(-text => decode('utf8',"perl_path"), -command => \&onPerlpath)->pack(-side => "left");

#####################
#
#メイン画面にフレームを生成します
#
#
#
#
#
#####################

EOS

    $labelText = decode('utf8',$text); 
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText);
}


#サブルーチン
sub onSub{

$text = <<'EOS';
sub onSubroutine{

#####################
#↓ここから下に処理を書く
#
#ここに処理を書く
#サブルーチンの書式です
#ラベルテキストの部分でデータを渡しますので消さないでください
#
#↑ここから上に処理を書く
#####################


$labelText = decode('utf8',$text); 

}

#####################
#本ソフト拡張の関数です
#関数名を任意に変更してボタンで呼び出します
#サブルーチンの書式です
#
#
#####################
EOS

    $labelText = decode('utf8',$text); 
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText);
}


#デコード日本語に変える
sub onDecode{

$text = <<'EOS';

use Encode qw(decode);
$as=decode('utf8',"複数コメント");

#####################
#
#文字コードの変更ができます
#エンコードモジュールをuse
#すると使えます
#無いと文字化けします
#
#####################
EOS

    $labelText = decode('utf8',$text); 
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText);
}

#デコード日本語に変える
sub onCodend{

$text = <<'EOS';


# メインループ
MainLoop();


#####################
#
#Tkで作ったスクリプトはスクリプトの
#最後にこれがないと動作しません
#
#####################


EOS

    $labelText = decode('utf8',$text); 
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText);
}

#-----------------------------------f3-------------------------------------

#CGIのフォーム
sub onForm{

$text = <<'EOS';


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">
<html>
<head><title>クリップボード</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta http-equiv="Content-Style-Type" content="text/css">
<meta name="GENERATOR" content="JustSystems Homepage Builder Version 19.0.12.0 for Windows">
<link href="webclip.css" rel="stylesheet" type="text/css">
<style type="text/css">
<!--

.style1{
	text-align: center;
}
-->
</style>
</head>
<body>
	<h1>WEBクリップボード</h1>

<a href='hyouji.cgi' target='new'>登録データ表示</a>

	<form action="webclip.cgi" method="POST" style="width: 600px">
		<table style="width: 166%">
			<tr>
				<td style="width: 79px" class="style1">登　録</td>
				<td style="width: 25px" class="style1">：</td>
				<td style="width: 529px">
				<textarea name="name" style="height: 500px; width: 500px"></textarea></td>
			</tr>
			</table>
		<input type="submit" value="メモリー登録">
		<input type="reset" value="リセット">
	</form>

</body>
</html>



EOS

    $labelText = decode('utf8',$text);
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText); 
}


# ipadd表示
sub onIpadd {
    $labelText = `ifconfig`;     
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText);
};

# sendmail表示
sub onSendmail {
    $labelText = `which sendmail`;    
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText);
};


# インターフェース状況表示
sub onNetstat {
    $labelText = `netstat -i`;    
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText);
}; 

# bashシェルのパス表示
sub onBash {
    $labelText = `which bash`;    
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText);
};


#-----------------------------------f4-------------------------------------
#CGIテンプレート
sub onCgitemp{

$text = <<'EOS';

#!/usr/bin/perl

#┌────────────────────────────────
#│ WEBClip v1.00 (2014/04/27)
#│ Copyright (c) Dotmatrix
#│ info@cgishop.net
#│ https://cgishop.net/
#└────────────────────────────────
$ver = 'WEBClip v1.00';
#┌────────────────────────────────
#│ [注意事項]
#│ 1. このスクリプトは、フリーソフトです。このスクリプトを使用した
#│    いかなる損害に対して作者は、一切の責任を負いません。
#│ 2. 直接メールによる質問は、お受けいたしておりません。
#│    
#│ 3. 送信フォームのHTMLページの作成に関しては、創作自由です。
#│    スクリプトは、よく勉強してから改造してください。
#│ 4. 良いご意見が有ればHPで受け付けます。
#│    前向きに検討し、今後の参考とさせていただきます。
#└────────────────────────────────

#
#  [ 設置例 ]
#
#  public_html / index.html (トップページ等）
#       |
#       +-- webclip / webclip.cgi [705]
#                     webclip.txt    [666] 
#




#=== 設定（ここから）=============================================

#戻る
$modoru = "https://cgishop.net/" ;

# カットする最大記事数の数（初期値：20個まで表示）
$max='365000';

#=== 設定終了（ここまで）=========================================


#=== 初期読み込み処理=============================================
use utf8;
use Encode 'decode';


#=== 時刻取得=====================================================

($sec,$min,$hour,$day,$mon,$year,$wday) = localtime(time);

$year=$year+1900;

$mon++;
@week = ("日","月","火","水","木","金","土");
$yobi = $week[$wday];


#=== 受信処理=== ==================================================


if ($ENV{'REQUEST_METHOD'} eq "POST") { read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'}); }
else { $buffer = $ENV{'QUERY_STRING'}; }

#=== デコード処理 =================================================

if ($buffer eq "") { &error; }
@pairs = split(/&/,$buffer);

foreach $pair (@pairs) {

	($name, $value) = split(/=/, $pair);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	
	$value = decode('UTF-8', $value);
	$FORM{$name} = $value;
}

# コメント本文の改行処理
	$FORM{'name'} =~ s/\r\n/<br>/g;
	$FORM{'name'} =~ s/\r/<br>/g;
	$FORM{'name'} =~ s/\n/<br>/g;



$ab = $FORM{'name'};
$ab =~ s/<br>//g;
$num = length("$ab");




#ファイルを読み込み
open (IN,"webclip.txt");
@aaa = <IN>;
close (IN);

unshift (@aaa,"$FORM{'name'}\n<br>"."文字数："."$num\n<br>"."入力時刻："."$year/$mon/$day _ $hour:$min"."<hr>");




#=== 画面表示 ===

print "Content-type: text/html\n\n"; 

print "<html><head><title>クリップボード</title><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF8\"></head>\n";
print "<body>\n";




print << "title" ;

<br>

title


print << "TOPMENU";

<table>

TOPMENU

# 最大記事数を超える記事をカット
	while ( $max < @aaa) { pop(@aaa); }

	
# 書き込み処理
open (OUT, ">webclip.txt");
print OUT @aaa;
close (OUT);


foreach $youso (@aaa)
{
		
		
		print "<tr><td> $youso<br><br> </td></tr>";
	
		$count++;
}


print "</table>";




#以下著作

print << "tyosaku" ;
<a href='webclip.html' target='new'>戻る</a>

<center><small>

<!-- $ver -->
<a href='https://cgishop.net/' target='new'>CGI Shop</a>

</small></center>


</BODY>
</HTML>

tyosaku

#===　表示サブルーチン　=====================================

sub error {
    print "Content-type: text/html\n\n";
    
    print "<html><head><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF8\"><title>登録データ</title></head>\n";
    print "<body>\n";
    print "<table>\n";

#ファイルを読み込み
open (IN,"webclip.txt");
@aaa = <IN>;
close (IN);


foreach $youso (@aaa)
{
		
		
		print "<tr><td> $youso<br><br> </td></tr>";
	
		$count++;
}


print "</table>";
print "<br><br><br>$count"."list";


    print "</body></html>\n";
    exit;
}

__END__



EOS

    $labelText = decode('utf8',$text); 
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText);
}

#ノートブック（タブページ）処理とフレームの処理、フレームの入れ子処理
sub onPageframe{

$text = <<'EOS';

#-----------------------ノートブック処理----------------------------------------

#トップにノートを載せる

use Tk::NoteBook;


$nb=$top->NoteBook()->pack(-fill => 'both',
-expand => 'yes');
#ページを作成する

$page1 = $nb->add("page1", -label=>"ボタン");
$page2 = $nb->add("page2", -label=>"test2");


#ページにボタンを載せる

$page1->Button(-fg => 'blue',-font => ['','10','bold'],-text=> "select＆copy",-command=> \&Print_selection)->pack(-side=>'left',-anchor=>'w');
$page1->Button(-text=> "copy",-command=> \©)->pack(-side=>'left',-anchor=>'w');
$page1->Button(-text=> "終了",-command=> \&onExit)->pack(-side=>'left',-anchor=>'s');



##----------------------------------ここまでがページ処理---------------------------------------

##ページを作ってその上にフレームでボタンとかの並びを変えるための処理



#topにノートを載せpageを作り、pageにフレームを載せてボタンを載せる

#ノートのpage1にフレームを載せる。これをf1オブジェクトとする

$f1 = $page1->Frame(-borderwidth => 2, -relief => 'groove')->pack();
#f1オブジェクトにボタンを載せる
$f1->Button(-text => 'button1, frame3')->pack();

##-------------------------------------------------------------
##ここから下はフレームの中にフレームをつけてボタンを載せる処理---------------------------------------

#f1オブジェクトにフレームを載せる.これをf2オブジェクトとする
#f1の中にフレームができたことになる

$f2=$f1->Frame(-borderwidth => 2, -relief => 'groove')->pack();

#内側にボタンを載せる
$f2->Button(-text => 'button1, frame3')->pack();
$f2->Button(-text => 'button1, frame3')->pack(-side=>'left',-anchor=>'w');



##ここまでがタブページを作ってフレームを載せて更にフレームを入れて配置する入れ子の処理


EOS

    $labelText = decode('utf8',$text); 
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText);
}





#-----------------------------------f5-------------------------------------







#-----------------------------------menu関数-------------------------------------

#ヒアドキュメント
sub onReadme{

$text = <<'EOS';

apt-getでperlTkをインストール
apt-get install perl-tk
CPANでinstallTkをしてからお使いください
cpan 
install  Tk
途中なにか聞かれたらｙで大丈夫です
参考URL
https://cgishop.jp/2022/08/09/perl-tk/


EOS

    $labelText = decode('utf8',$text); 
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText);
}
# 終了
sub onExit {
    exit;  
};


#著作権表示
sub onHirano{

$text = <<'EOS';

<Copyright>

Shigemitsu Hirano

hirano@cgishop.net

https://cgishop.net
今後ともよろしくお願いします

EOS

    $labelText = decode('utf8',$text); 
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $labelText);
}






#-----------------------------------code_end-------------------------------------

# メインループ
MainLoop();
